import {
  select,
  csv,
  scaleLinear,
  max,
  scaleBand,
  axisLeft,
  axisBottom,
  format,
  scale
} from 'd3';

const xAxisLabelText = 'IMDBrating';

const svg = select('svg')
;

const width = +svg.attr('width');
const height = +svg.attr('height');

const render = chartJson => {
  var tooltip = d3.select("body")
      .append("div")
      .style("position", "absolute")
      .style("z-index", "8")
      .style("visibility", "hidden")
      .style("background", "#fff")
      .text("a simple tooltip");
  const data = chartJson.data;
  const xValue = d => d[chartJson.xAxisKey];
  const yValue = d => d[chartJson.yAxisKey];
  const margin = { top: 100, right: 140, bottom: 208, left: 280 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  const radius = Math.min(width, height) / 2.12;
  const color = d3.scaleOrdinal(d3.schemeCategory10);
  
  const g = svg.append("g")
  .text("mcu")
  .data([data]) 
  .attr("transform", "translate(" + width / 2 + "," + height / 2 + ")");
  
  var arc = d3.arc()
					.innerRadius(0)
					.outerRadius(radius);

    var pie = d3.pie()           
        .value(function(d) { return parseInt(d.IMDBrating); });    

    var arcs = g.selectAll("g.slice")     
        .data(pie)                        
        .enter()                           
            .append("svg:g")               
                .attr("class", "slice"); 
  
        var section = arcs.append("svg:path")
                .attr("fill", function(d, i) { return color(i); } ) 
                .attr("d", arc);      
  

        
  
  
  
  if(chartJson.clickEvent){
  	section.on("click", (data)=>{
      console.log(data)
      alert(chartJson.yAxisLabel+ " : " +yValue(data.data) + ", "+chartJson.xAxisLabel  + " : " + xValue(data.data)); return tooltip.style("visibility", "visible");
    })
  }
   if(chartJson.hoverEvent){
  	section.on("mouseover", (data)=>{
      tooltip.text(chartJson.yAxisLabel+ " : " +yValue(data.data) + ", "+chartJson.xAxisLabel  + " : " + xValue(data.data)); return tooltip.style("visibility", "visible");
    })
 
    .on("mousemove", ()=>{return tooltip.style("top", (d3.event.pageY-10)+"px").style("left",(d3.event.pageX+10)+"px");})
    .on("mouseout", ()=>{
      return tooltip.style("visibility", "hidden");
    }); 
  } 
  
};

csv('https://gist.githubusercontent.com/happymail6/cd134b642115a7bff663865b0b0bbeb2/raw/b973000ac5b23b8f6ac95729a789a7d30c68aa04/MCU.csv').then(data => {
  data.forEach(d => {
    	d.Phase = +d.Phase ; 
      d.USreleaseDate = new Date(d.USreleaseDate)
    })
  // set the chart configration here
  // css will be set via theme
  // need to use generic class across the charts
  // chart title will be show out of chart svg
  console.log(data)
  const chartJson = {
    chartType: 'bar',
  	data: data,
    xAxisKey : 'IMDBrating',
    yAxisKey: 'Name',
    xAxisLabel: 'IMDBrating',
    yAxisLabel: 'Name',
    xAxisLabelVisible: false,
    yAxisLabelVisible: false,
    verticleGridLine: false,
    horizontalGridLine: false,
    clickEvent: true,
    hoverEvent: true
  };
  render(chartJson);
});